libzypp: zypp::sat::Transaction::Impl Struct Reference

libzypp 17.38.11

zypp::sat::Transaction::Impl Struct Reference

Transaction implementation. More...

Inheritance diagram for zypp::sat::Transaction::Impl:

## Classes
struct | PostMortem

## Public Types
using | set_type = std::unordered_set<detail::IdType>
using | map_type = std::unordered_map<detail::IdType, detail::IdType>
using | pmmap_type = std::unordered_map<detail::IdType, PostMortem>

## Public Member Functions
| Impl ()
| Impl (const Impl &)=delete
| Impl (Impl &&)=delete
Impl & | operator= (const Impl &)=delete
Impl & | operator= (Impl &&)=delete
| Impl (LoadFromPoolType)
| ~Impl ()
bool | valid () const
bool | order ()
bool | empty () const
size_t | size () const
const_iterator | begin (const RW_pointer< Transaction::Impl > &self_r) const
iterator | begin (const RW_pointer< Transaction::Impl > &self_r)
const_iterator | end (const RW_pointer< Transaction::Impl > &self_r) const
iterator | end (const RW_pointer< Transaction::Impl > &self_r)
const_iterator | find (const RW_pointer< Transaction::Impl > &self_r, const sat::Solvable &solv_r) const
iterator | find (const RW_pointer< Transaction::Impl > &self_r, const sat::Solvable &solv_r)
int | installedResult (Queue &result_r) const
StringQueue | autoInstalled () const
void | autoInstalled (const StringQueue &queue_r)
StepType | stepType (Solvable solv_r) const
StepStage | stepStage (Solvable solv_r) const
void | stepStage (Solvable solv_r, StepStage newval_r)
const PostMortem & | pmdata (Solvable solv_r) const

## Static Public Member Functions
static shared_ptr< Impl > | nullimpl ()
| Offer default Impl.

## Private Member Functions
detail::IdType | resolve (const Solvable &solv_r) const
bool | isIn (const set_type &set_r, detail::IdType sid_r) const
StepStage | stepStage (detail::IdType sid_r) const
void | stepStage (detail::IdType sid_r, StepStage newval_r)
detail::IdType * | _find (const sat::Solvable &solv_r) const

## Private Attributes
SerialNumberWatcher | _watcher
mutable::Transaction * | _trans
DefaultIntegral< bool, false > | _ordered
set_type | _doneSet
set_type | _errSet
map_type | _linkMap
set_type | _systemErase
pmmap_type | _pmMap
StringQueue | _autoInstalled

## Friends
std::ostream & | operator<< (std::ostream &str, const Impl &obj)
| relates: Transaction::Impl Stream output

## Additional Inherited Members
Static Protected Member Functions inherited from zypp::sat::detail::PoolMember
static PoolImpl & | myPool ()
static bool | poolValid ()

## Detailed Description

Transaction implementation.

\NOTE After commit the @System repo is reloaded. This invalidates the ids off all installed items in the transaction, including their stepType. Thats why some information (stepType, NVRA) is be stored for post mortem access (i.e. tell after commit which NVRA were deleted).

Definition at line 49 of file Transaction.cc.

## Member Typedef Documentation

## ◆ set_type

using zypp::sat::Transaction::Impl::set_type = std::unordered_set<detail::IdType>

Definition at line 55 of file Transaction.cc.

## ◆ map_type

using zypp::sat::Transaction::Impl::map_type = std::unordered_map<detail::IdType, detail::IdType>

Definition at line 56 of file Transaction.cc.

## ◆ pmmap_type

using zypp::sat::Transaction::Impl::pmmap_type = std::unordered_map<detail::IdType, PostMortem>

Definition at line 72 of file Transaction.cc.

## Constructor & Destructor Documentation

## ◆ Impl() [1/4]

zypp::sat::Transaction::Impl::Impl | ( |  | ) |
| inline

Definition at line 75 of file Transaction.cc.

## ◆ Impl() [2/4]

zypp::sat::Transaction::Impl::Impl | ( | const Impl & |  | ) |
| delete

## ◆ Impl() [3/4]

zypp::sat::Transaction::Impl::Impl | ( | Impl && |  | ) |
| delete

## ◆ Impl() [4/4]

zypp::sat::Transaction::Impl::Impl | ( | LoadFromPoolType |  | ) |
| inline

Definition at line 84 of file Transaction.cc.

## ◆ ~Impl()

zypp::sat::Transaction::Impl::~Impl | ( |  | ) |
| inline

Definition at line 131 of file Transaction.cc.

## Member Function Documentation

## ◆ operator=() [1/2]

Impl & zypp::sat::Transaction::Impl::operator= | ( | const Impl & |  | ) |
| delete

## ◆ operator=() [2/2]

Impl & zypp::sat::Transaction::Impl::operator= | ( | Impl && |  | ) |
| delete

## ◆ valid()

bool zypp::sat::Transaction::Impl::valid | ( |  | ) | const
| inline

Definition at line 135 of file Transaction.cc.

## ◆ order()

bool zypp::sat::Transaction::Impl::order | ( |  | ) |
| inline

Definition at line 138 of file Transaction.cc.

## ◆ empty()

bool zypp::sat::Transaction::Impl::empty | ( |  | ) | const
| inline

Definition at line 170 of file Transaction.cc.

## ◆ size()

size_t zypp::sat::Transaction::Impl::size | ( |  | ) | const
| inline

Definition at line 173 of file Transaction.cc.

## ◆ begin() [1/2]

const_iterator zypp::sat::Transaction::Impl::begin | ( | const RW_pointer< Transaction::Impl > & | self_r | ) | const
| inline

Definition at line 176 of file Transaction.cc.

## ◆ begin() [2/2]

iterator zypp::sat::Transaction::Impl::begin | ( | const RW_pointer< Transaction::Impl > & | self_r | ) |
| inline

Definition at line 178 of file Transaction.cc.

## ◆ end() [1/2]

const_iterator zypp::sat::Transaction::Impl::end | ( | const RW_pointer< Transaction::Impl > & | self_r | ) | const
| inline

Definition at line 181 of file Transaction.cc.

## ◆ end() [2/2]

iterator zypp::sat::Transaction::Impl::end | ( | const RW_pointer< Transaction::Impl > & | self_r | ) |
| inline

Definition at line 183 of file Transaction.cc.

## ◆ find() [1/2]

const_iterator zypp::sat::Transaction::Impl::find | ( | const RW_pointer< Transaction::Impl > & | self_r,
|  | const sat::Solvable & | solv_r ) const
| inline

Definition at line 186 of file Transaction.cc.

## ◆ find() [2/2]

iterator zypp::sat::Transaction::Impl::find | ( | const RW_pointer< Transaction::Impl > & | self_r,
|  | const sat::Solvable & | solv_r )
| inline

Definition at line 188 of file Transaction.cc.

## ◆ installedResult()

int zypp::sat::Transaction::Impl::installedResult | ( | Queue & | result_r | ) | const
| inline

Definition at line 192 of file Transaction.cc.

## ◆ autoInstalled() [1/2]

StringQueue zypp::sat::Transaction::Impl::autoInstalled | ( |  | ) | const
| inline

Definition at line 195 of file Transaction.cc.

## ◆ autoInstalled() [2/2]

void zypp::sat::Transaction::Impl::autoInstalled | ( | const StringQueue & | queue_r | ) |
| inline

Definition at line 198 of file Transaction.cc.

## ◆ stepType()

StepType zypp::sat::Transaction::Impl::stepType | ( | Solvable | solv_r | ) | const
| inline

Definition at line 202 of file Transaction.cc.

## ◆ stepStage() [1/4]

StepStage zypp::sat::Transaction::Impl::stepStage | ( | Solvable | solv_r | ) | const
| inline

Definition at line 219 of file Transaction.cc.

## ◆ stepStage() [2/4]

void zypp::sat::Transaction::Impl::stepStage | ( | Solvable | solv_r,
|  | StepStage | newval_r )
| inline

Definition at line 222 of file Transaction.cc.

## ◆ pmdata()

const PostMortem & zypp::sat::Transaction::Impl::pmdata | ( | Solvable | solv_r | ) | const
| inline

Definition at line 225 of file Transaction.cc.

## ◆ resolve()

detail::IdType zypp::sat::Transaction::Impl::resolve | ( | const Solvable & | solv_r | ) | const
| inlineprivate

Definition at line 233 of file Transaction.cc.

## ◆ isIn()

bool zypp::sat::Transaction::Impl::isIn | ( | const set_type & | set_r,
|  | detail::IdType | sid_r ) const
| inlineprivate

Definition at line 239 of file Transaction.cc.

## ◆ stepStage() [3/4]

StepStage zypp::sat::Transaction::Impl::stepStage | ( | detail::IdType | sid_r | ) | const
| inlineprivate

Definition at line 242 of file Transaction.cc.

## ◆ stepStage() [4/4]

void zypp::sat::Transaction::Impl::stepStage | ( | detail::IdType | sid_r,
|  | StepStage | newval_r )
| inlineprivate

Definition at line 251 of file Transaction.cc.

## ◆ _find()

detail::IdType * zypp::sat::Transaction::Impl::_find | ( | const sat::Solvable & | solv_r | ) | const
| inlineprivate

Definition at line 269 of file Transaction.cc.

## ◆ nullimpl()

shared_ptr< Impl > zypp::sat::Transaction::Impl::nullimpl | ( |  | ) |
| inlinestatic

Offer default Impl.

Definition at line 297 of file Transaction.cc.

## Friends And Related Symbol Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | str,
|  | const Impl & | obj )
| friend

relates: Transaction::Impl Stream output

Definition at line 305 of file Transaction.cc.

## Member Data Documentation

## ◆ _watcher

SerialNumberWatcher zypp::sat::Transaction::Impl::_watcher
| private

Definition at line 283 of file Transaction.cc.

## ◆ _trans

mutable::Transaction* zypp::sat::Transaction::Impl::_trans
| private

Definition at line 284 of file Transaction.cc.

## ◆ _ordered

DefaultIntegral<bool,false> zypp::sat::Transaction::Impl::_ordered
| private

Definition at line 285 of file Transaction.cc.

## ◆ _doneSet

set_type zypp::sat::Transaction::Impl::_doneSet
| private

Definition at line 287 of file Transaction.cc.

## ◆ _errSet

set_type zypp::sat::Transaction::Impl::_errSet
| private

Definition at line 288 of file Transaction.cc.

## ◆ _linkMap

map_type zypp::sat::Transaction::Impl::_linkMap
| private

Definition at line 289 of file Transaction.cc.

## ◆ _systemErase

set_type zypp::sat::Transaction::Impl::_systemErase
| private

Definition at line 290 of file Transaction.cc.

## ◆ _pmMap

pmmap_type zypp::sat::Transaction::Impl::_pmMap
| private

Definition at line 291 of file Transaction.cc.

## ◆ _autoInstalled

StringQueue zypp::sat::Transaction::Impl::_autoInstalled
| private

Definition at line 293 of file Transaction.cc.

The documentation for this struct was generated from the following file:

- zypp/sat/Transaction.cc